<?php
declare(strict_types=1);

namespace App\Pay\Zhifuxpay\Impl;


class Signature implements \App\Pay\Signature
{

    /**
     * 生成签名 待签名字符串=商户号+商户订单号+支付金额+异步通知地址+接入密钥
     * @param array $data
     * @param string $hashKey
     * @return string
     */
    public static function generateSignature(array $data, string $hashKey): string
    {
        
        $arg = $data['merchantNum'].$data['orderNo'].$data['amount'].$data['notifyUrl'];
        return md5($arg . $hashKey);
    }

     /**
     * 生成签名 签名值=md5(付款成功状态state的值+商户号merchantNum的值+商户订单号orderNo的值+订单金额amount的值+接入密钥)；
     * @param array $data
     * @param string $hashKey
     * @return string
     */
    public static function generateSignatureCallback(array $data, string $hashKey): string
    {
        
        $arg = $data['state'].$data['merchantNum'].$data['orderNo'].$data['amount'];
        return md5($arg . $hashKey);
    }

    /**
     * @inheritDoc
     */
    public function verification(array $data, array $config): bool
    {
        $sign = $data['sign'];
        unset($data['sign']);
        $generateSignature = self::generateSignatureCallback($data, $config['key']);
        if ($sign != $generateSignature) {
            return false;
        }
        return true;
    }
}